class CitizenHandler
{
   var oHandler;
   var nRelease = 0;
   var cRelease = 0;
   var highThresh = 0.8;
   var lowThresh = 4;
   var levelInc = 0.3;
   var windChance = 3;
   function CitizenHandler(loc)
   {
      var _loc1_ = this;
      var _loc2_ = loc;
      _loc1_.location = _loc2_;
      _loc1_.oHandler = new smashing.ClipHandler(_loc2_);
      _loc1_.totalThresh = _loc1_.lowThresh - _loc1_.highThresh;
   }
   function update(nElapsed)
   {
      var _loc3_ = this.oHandler.clips;
      var l = _loc3_.length;
      var _loc2_ = undefined;
      var _loc1_ = 0;
      while(_loc1_ < l)
      {
         _loc2_ = _loc3_[_loc1_];
         if(_loc2_ != null)
         {
            _loc2_.update(nElapsed);
            _loc2_.render();
         }
         _loc1_ = _loc1_ + 1;
      }
      this.cRelease += nElapsed;
      if(this.cRelease >= this.nRelease)
      {
         this.cRelease = 0;
         this.addCitizen();
      }
   }
   function addCitizen()
   {
      var _loc2_ = this;
      var side = Math.floor(Math.random() * 2) != 1 ? -1 : 1;
      var disp = smashing.Viewport.halfHeight - Citizen.nRange;
      var pos = Math.random() * disp * side;
      var _loc1_ = undefined;
      var _loc3_ = Math.floor(Math.random() * _loc2_.windChance);
      if(_loc3_ == 0)
      {
         _global.oSound.playSnd("wind");
         _loc1_ = _loc2_.oHandler.addClip("mcWind");
      }
      else
      {
         _global.oSound.playSnd("citizenSound");
         _loc1_ = _loc2_.oHandler.addClip("mcCitizen");
      }
      _loc1_.x = smashing.Viewport.x + smashing.Viewport.halfWidth + _loc1_.r;
      _loc1_.baseY = smashing.Viewport.y + pos;
      _loc1_.y = _loc1_.baseY;
      _loc1_.oCitizenHandler = _loc2_;
      _loc1_.oBuildings = _loc2_.oBuildings;
      _loc1_.render();
   }
   function removeCitizen(o)
   {
      this.oHandler.removeClip(o);
   }
   function setRatio(nRatio)
   {
      var _loc1_ = nRatio;
      var _loc2_ = this;
      _loc1_ = 1 - _loc1_;
      _loc2_.nRelease = _loc1_ * _loc2_.totalThresh + _loc2_.highThresh;
   }
   function reset()
   {
      this.oHandler.removeAllClips();
   }
   function setLevel(nLevel)
   {
      var _loc1_ = this;
      nLevel -= 1;
      _loc1_.totalThresh = _loc1_.lowThresh - _loc1_.highThresh - nLevel * _loc1_.levelInc;
      if(_loc1_.totalThresh < 0)
      {
         _loc1_.totalThresh = 0;
      }
   }
}
